org.cpsolver.studentsct.heuristics

## Class TwoPhaseStudentSctNeighbourSelection

- java.lang.Object
- - org.cpsolver.ifs.heuristics.StandardNeighbourSelection<V,T>
  - - org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection<Request,Enrollment>
    - - org.cpsolver.studentsct.heuristics.StudentSctNeighbourSelection
      - - org.cpsolver.studentsct.heuristics.TwoPhaseStudentSctNeighbourSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>, SolverListener<Request,Enrollment>

      public class TwoPhaseStudentSctNeighbourSelection
      extends StudentSctNeighbourSelection

  Two-phase (Batch) student sectioning neighbour selection. It is based on `StudentSctNeighbourSelection`, however in the first round, only real students are sectioned. All dummy students are removed from the problem during initialization of this neighbour selection, they are returned into the problem after the first round of `StudentSctNeighbourSelection`.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `TwoPhaseStudentSctNeighbourSelection.RestoreDummyStudents` Return all dummy students into the problem, executed as the last phase of the first round

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection

      `iSolver, sLogger`

    - ### Fields inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `iStat`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TwoPhaseStudentSctNeighbourSelection(DataProperties properties)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Request,Enrollment> solver)` Initialization -- also remove all the dummy students from the problem

    - ### Methods inherited from class org.cpsolver.studentsct.heuristics.StudentSctNeighbourSelection

      `changeSelection, neighbourFailed, neighbourSelected, setup, valueSelected, variableSelected`

    - ### Methods inherited from class org.cpsolver.ifs.heuristics.RoundRobinNeighbourSelection

      `getSelection, getSelectionIndex, registerSelection, selectNeighbour`

    - ### Methods inherited from class org.cpsolver.ifs.heuristics.StandardNeighbourSelection

      `getValueSelection, getVariableSelection, selectValue, selectVariable, setValueSelection, setVariableSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TwoPhaseStudentSctNeighbourSelection

          public TwoPhaseStudentSctNeighbourSelection(DataProperties properties)
                                               throws Exception

      Throws:
        `Exception`

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Initialization -- also remove all the dummy students from the problem
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Overrides:
        `init` in class `StudentSctNeighbourSelection`
      Parameters:
        `solver` - current solver